
import javafx.application.Application
import javafx.scene.Scene
import javafx.scene.layout.Pane
import javafx.scene.shape.Line
import javafx.stage.Stage

/**objet contenant la méthode main appelant la fenetre javafx*/
object Rosace {
  def main(args: Array[String]): Unit = {
    Application.launch(classOf[TestRosace], args: _*)
  }
}

/**classe representant une fenêtre*/
class TestRosace extends javafx.application.Application {
  /**largeur d'un côté en pixel*/
  val cote = 600

  /**dessine les lignes corresponsant à une rosace
   * @param nbPoints = nb de lignes par côté
   * @param root = racine du paneau où dessiner les lignes*/
  def dessineRosace(nbPoints:Int, root:Pane)
  {
    //léger décalage en y car la barre de menu deborde un peu sur le panneau
    val menu = 10
    var l1,l2,l3,l4:Line= null
    var marge = cote/nbPoints
    for (i<-0 to cote by marge)
    {
      l1 = new Line(i,menu , cote,i+menu)
      l2 = new Line(cote,i+menu, cote-i,cote )
      l3 = new Line(cote-i,cote , 0,cote-i+menu)
      l4 = new Line(0,cote-i+menu , i,menu)
      root.getChildren.addAll(l1,l2, l3, l4);
    }
  }

  /**création de la fenêtre*/
  override def start(primaryStage: Stage): Unit = {
    //titre de la fenêtre
    primaryStage.setTitle("Rosace");
    //panneau de dessin
    val root = new Pane()
    primaryStage.setScene(new Scene(root, cote, cote))
    //affichage de la fenêtre
    primaryStage.show()
    //dessin de la rosace
    dessineRosace(100, root)
  }

}
